package kaysaar.aotd_question_of_loyalty.data.ui;

import com.fs.starfarer.api.campaign.BaseCustomUIPanelPlugin;
import com.fs.starfarer.api.impl.campaign.rulecmd.FireBest;
import kaysaar.aotd_question_of_loyalty.data.scripts.commision.AoTDCommissionUtil;
import org.jetbrains.annotations.NotNull;
import java.awt.Color;
import com.fs.starfarer.api.util.Misc;
import com.fs.starfarer.api.Global;
import java.util.Iterator;
import com.fs.starfarer.api.ui.LabelAPI;
import com.fs.starfarer.api.ui.TooltipMakerAPI;
import com.fs.starfarer.api.ui.UIComponentAPI;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDCommIntelPlugin;
import com.fs.starfarer.api.ui.Alignment;
import com.fs.starfarer.api.campaign.CustomUIPanelPlugin;
import com.fs.starfarer.api.ui.CustomPanelAPI;
import java.util.ArrayList;
import com.fs.starfarer.api.campaign.rules.MemoryAPI;
import java.util.Map;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import com.fs.starfarer.api.ui.ButtonAPI;
import java.util.List;
import com.fs.starfarer.api.campaign.CustomDialogDelegate;

public class RankShowcaseUIDialog implements CustomDialogDelegate
{
    public static final float WIDTH = 600.0f;
    public static final float HEIGHT;
    public List<ButtonAPI> buttons;
    String selected;
    InteractionDialogAPI dialog;
    Map<String, MemoryAPI> memoryMap;
    
    public RankShowcaseUIDialog(final InteractionDialogAPI dialogAPI, final Map<String, MemoryAPI> memoryMap) {
        this.buttons = new ArrayList<ButtonAPI>();
        this.dialog = dialogAPI;
        this.memoryMap = memoryMap;
    }
    
    public void createCustomDialog(final CustomPanelAPI panel, final CustomDialogDelegate.CustomDialogCallback callback) {
        final CustomPanelAPI panelS = panel.createCustomPanel(600.0f, RankShowcaseUIDialog.HEIGHT, (CustomUIPanelPlugin)new ButtonReportingCustomPanel(this));
        final TooltipMakerAPI panelTooltip = panelS.createUIElement(600.0f, RankShowcaseUIDialog.HEIGHT, true);
        final LabelAPI labelAPI = panelTooltip.addSectionHeading("Select a rank", Alignment.MID, 0.0f);
        for (final String s : AoTDCommIntelPlugin.get().getRanksForPromotion()) {
            final ButtonAPI button = this.makeButton(panelTooltip, s, AoTDCommIntelPlugin.get().isStageActive((Object)s));
            this.buttons.add(button);
            panelTooltip.setHeightSoFar(-button.getPosition().getY());
            panelTooltip.addSpacer(5.0f);
        }
        panelS.addUIElement(panelTooltip).inTL(0.0f, 0.0f);
        panel.addComponent((UIComponentAPI)panelS).inTL(0.0f, 0.0f);
    }
    
    @NotNull
    private ButtonAPI makeButton(final TooltipMakerAPI panelTooltip, final String role, final boolean stageActive) {
        final TooltipMakerAPI dummy = panelTooltip.beginSubTooltip(590.0f);
        final Color base = Global.getSector().getPlayerFaction().getBaseUIColor();
        final Color bg = Global.getSector().getPlayerFaction().getDarkUIColor();
        final Color highlight = Global.getSector().getPlayerFaction().getBrightUIColor();
        AoTDCommIntelPlugin.get().getStageTooltipImpl((Object)role).createTooltip(dummy, true, (Object)null);
        if (stageActive) {
            dummy.addPara("You met requirement", Misc.getPositiveHighlightColor(), 10.0f);
        }
        else {
            dummy.addPara("You have not met requirement", Misc.getNegativeHighlightColor(), 10.0f);
        }
        final ButtonAPI button = panelTooltip.addAreaCheckbox("", (Object)role, base, bg, highlight, 590.0f, dummy.getHeightSoFar() + 10.0f, 5.0f);
        button.setEnabled(stageActive);
        panelTooltip.endSubTooltip();
        panelTooltip.addCustom((UIComponentAPI)dummy, 0.0f).getPosition().inTL(button.getPosition().getX(), -button.getPosition().getY() - button.getPosition().getHeight() + 5.0f);
        final ButtonAPI buttonAPI = button;
        if (buttonAPI == null) {
            $$$reportNull$$$0(0);
        }
        return buttonAPI;
    }
    
    public boolean hasCancelButton() {
        return true;
    }
    
    public String getConfirmText() {
        return null;
    }
    
    public String getCancelText() {
        return null;
    }
    
    public void customDialogConfirm() {
        Global.getSector().getMemory().set("$aotd_rank_temp", (Object)this.selected, 0.1f);
        AoTDCommissionUtil.reportPlayerGotNewRank(AoTDCommIntelPlugin.get().getCurrentRankData());
        FireBest.fire((String)null, this.dialog, (Map)this.memoryMap, "AotdPromotion");
    }
    
    public void customDialogCancel() {
    }
    
    public CustomUIPanelPlugin getCustomPanelPlugin() {
        return null;
    }
    
    public void reportButtonPressed(final Object id) {
        this.selected = (String)id;
        for (final ButtonAPI button : this.buttons) {
            if (button.isChecked() && button.getCustomData() != id) {
                button.setChecked(false);
            }
        }
    }
    
    static {
        HEIGHT = Global.getSettings().getScreenHeight() - 500.0f;
    }
    
    private static /* synthetic */ void $$$reportNull$$$0(final int n) {
        throw new IllegalStateException(String.format("@NotNull method %s.%s must not return null", "kaysaar/aotd_question_of_loyalty/data/ui/RankShowcaseUIDialog", "makeButton"));
    }
    
    public static class ButtonReportingCustomPanel extends BaseCustomUIPanelPlugin
    {
        public RankShowcaseUIDialog delegate;
        
        public ButtonReportingCustomPanel(final RankShowcaseUIDialog delegate) {
            this.delegate = delegate;
        }
        
        public void buttonPressed(final Object buttonId) {
            super.buttonPressed(buttonId);
            this.delegate.reportButtonPressed(buttonId);
        }
    }
}
